<?php

// Подключение библиотек
$LIB = "/usr/share/verilator/include";
$INC = "$LIB/verilated.cpp $LIB/verilated_threads.cpp";
$OBJ = "";
$RUN = isset($argv[1]) && $argv[1] == 'run';

$touchfile = false;
$checkfile = [];

$files = [
    'tb.v'          => 'tb',
    'video.v'       => 'v',
    'tb.cc'         => 'c',
    'tb.h'          => 'c',
];

// Отыкарусить
echo `iverilog -g2005-sv -o tb.qqq tb.v video.v`;
echo `vvp tb.qqq -o tb.vcd > /dev/null`;

if (file_exists('tb.qqq')) {
    unlink('tb.qqq');
} else {
    exit;
}

// -----------------------------------------------------------------------------
// Компиляция Verilator, GCC
// -----------------------------------------------------------------------------

if ($RUN)
{
    $run = 1;

    if (!file_exists(".diff")) mkdir(".diff");

    // Скомпилировать, если надо)
    foreach ($files as $file => $type)
    {
        $tf = ".diff/.$file";
        $vf = str_replace('.v', '', $file);
        $ts = file_exists($tf) ? file_get_contents($tf) : 0;
        $mt = filemtime($file);
        $e1 = $e2 = false;

        $checkfile[] = $tf;

        if ($mt != $ts)
        {
            // Добавить в компиляцию
            if ($type == 'v')
            {
                $time = time();
                $e1 = (`verilator --threads 1 -cc $file`);
                $e2 = (`cd obj_dir && make -f V$vf.mk`);
                echo "[".(time() - $time)."] $file\n";
            }

            $touchfile = true;
        }

        if ($type == 'v') {
            $OBJ .= "obj_dir/V{$vf}__ALL.a ";
        }

        file_put_contents($tf, $mt);
    }

    // Требуется перекомпиляция
    if ($touchfile)
    {
        $time = time();
        $bash = "g++ -Ofast -Wno-unused-result -o tb -I$LIB tb.cc $INC $OBJ -lSDL2 2>&1";
        $err = `$bash`;

        echo "[".(time() - $time)."] GCC\n";

        // При обнаруженной ошибке -- сбросить успешные touch-файлы
        if ($err) { echo "ERROR:\n$bash\n$err"; foreach ($checkfile as $file) unlink($file); $run = 0; }
    }

    // Запуск программы -d
    if ($run) echo `./tb > tb.log`;
}
